<template>
  <v-form
    v-model="valid"
    ref="form"
    lazy-validation
    @submit="handleFormValidate"
  >
    <InputLocker :obj="obj" :locates="locates" />
    <div class="my-1" align="center">
      <v-btn
        type="submit"
        :disabled="loading"
        :loading="loading"
        color="primary"
        depressed
        medium
      >
        ยืนยันการส่งฟอร์ม
      </v-btn>
    </div>
    <DialogConfirm :dialog="dialogConfirm" :title="objDialog.title">
      <template v-slot:confirm>
        <v-btn
          color="success"
          text
          :disabled="loading"
          :loading="loading"
          @click="confirm"
        >
          ใช่
        </v-btn>
      </template>
      <template v-slot:close>
        <v-btn
          color="error"
          text
          :disabled="loading"
          @click="dialogConfirm = false"
        >
          ไม่ใช่
        </v-btn>
      </template>
    </DialogConfirm>
  </v-form>
</template>

<script>
import InputLocker from "./InputLocker";
import DialogConfirm from "../dialog/DialogConfirm";
export default {
  components: {
    InputLocker,
    DialogConfirm,
  },
  data() {
    return {
      valid: true,
      loading: false,
      obj: {},
      locates: [],
      objDialog: {},
      dialogConfirm: false,
    };
  },
  async created() {
    await this.fetchLocate();
  },
  methods: {
    async fetchLocate() {
      await this.$store.dispatch("locate/getLocationByAccountId");
      let error = this.$store.getters["locate/error"];
      if (error == false) {
        this.locates = this.$store.getters["locate/result"];
      } else {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "ข้อมูลจากระบบผิดพลาด",
          color: "red",
          timeout: 5500,
        });
      }
    },
    async handleFormValidate(e) {
      e.preventDefault();
      const formValid = this.$refs.form.validate();
      var lockerRoomResult =
        parseInt(this.obj.sAmount) +
          parseInt(this.obj.mAmount) +
          parseInt(this.obj.lAmount) >=
        5;
      if (formValid === true && lockerRoomResult) {
        this.dialogConfirm = true;
        this.objDialog.title = "คุณต้องการเพิ่มล็อกเกอร์หรือไม่";
      } else {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "ช่องล็อคเกอร์รวมกันต้องมีอย่างน้อย 5 ช่องขึ้นไป",
          color: "red",
          timeout: 6000,
        });
      }
    },
    async confirm() {
      this.loading = true;
      const param = {
        locateId: this.obj.locateSelected,
        sAmount: parseInt(this.obj.sAmount),
        mAmount: parseInt(this.obj.mAmount),
        lAmount: parseInt(this.obj.lAmount),
        optionalRequest: this.obj.optionalRequest,
        accountId: localStorage.getItem("accountId"),
      };
      await this.$store.dispatch("locker/addLockerRequest", param);
      let error = this.$store.getters["locker/error"];
      if (error == false) {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "เพิ่มช่องล็อคเกอร์สำเร็จ",
          color: "success",
          timeout: 6000,
        });
        this.loading = false;
        this.dialogConfirm = false;
        this.$router.replace({ name: "locker-list" });
      } else {
        await this.$store.dispatch("snackbar/showSnack", {
          text: "เพิ่มช่องล็อคเกอร์ไม่สำเร็จ",
          color: "red",
          timeout: 6000,
        });
        this.dialogConfirm = false;
        this.loading = false;
      }
    },
  },
};
</script>

<style>
</style>